config/routes.rb
Rails.application.routes.draw do

namespace :admin do
  resources :participants do
    post 'reset', on: :member
  end
  resources :communities do
    resources :participants
  end
  resources :organizations
  resources :ressources
end

scope :path => '/sys', :as => 'sys' do
  resources :memberships, :only => [:index]
  resources :events, :only => [:index] do
    match :fifo, :via => [:get, :post], :on => :collection
  end
  resources :configs, :only => [:index, :create]
  resources :subparticipants, :only => [:index, :show, :create, :update, :destroy]
end

begin
  Ressource.all.each do |r|
    scope :path => "/#{r.namespace}", :as => r.namespace  do
      resources r.ressource.to_sym, :controller => :messages, :only => [:index, :show, :create, :update, :destroy] do
        match :fifo, :via => [:get, :post], :on => :collection
        match :lifo, :via => [:get, :post], :on => :collection
        match :details, :via => [:get], :on => :collection
        match :details, :via => [:get], :on => :member
      end
    end
  end
rescue ActiveRecord::StatementInvalid
  Rails.logger.info "DB error: #{$!}"
end

resources :memberships, :only => [:index]
resources :events, :only => [:index] do
  match :fifo, :via => [:get, :post], :on => :collection
end

get '/admin' => 'admin/participants#index'
root 'admin/participants#default'

end

app/models/organization.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
# 
# This file is part of ECS.
# 
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
# 
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


class Organization < ApplicationRecord
  # TODO: warn the user about possible deletions of participants. 
  has_many :participants, :dependent => :destroy

  validates_presence_of :name, :abrev
  validates_uniqueness_of :name, :abrev

  def orgtext
    "#{name} (#{abrev})" 
  end
  def orgtext=(name)
    return 
  end
end

app/controllers/admin/organizations_controller.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
# 
# This file is part of ECS.
# 
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
# 
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


class Admin::OrganizationsController < ApplicationController

  include Admin::Helper

  # TODO verify http methods

  def index
    list
    render :action => 'list'
  end

  def list
    @organizations=Organization.all.distinct
  end

  def show
    @organization = Organization.find(params[:id])
  end

  def new
    @organization = Organization.new
  end

  def create
    @organization = Organization.new(organization_params)
    if @organization.save
      flash[:notice] = 'Organization was successfully created.'
      redirect_to :action => 'index'
    else
      render :action => 'new'
    end
  end

  def edit
    @organization = Organization.find(params[:id])
  end

  def update
    @organization = Organization.find(params[:id])
    if @organization.update(organization_params)
      flash[:notice] = 'Organization was successfully updated.'
      redirect_to :action => 'index'
    else
      render :action => 'edit'
    end
  end

  def destroy
    Organization.find(params[:id]).destroy
    redirect_to :action => 'index'
  end

private

  def organization_params
    params.require(:organization).permit(:name, :description, :abrev)
  end

end

app/helpers/admin/organizations_helper.rb
# Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).
# 
# This file is part of ECS.
# 
# ECS is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of
# the License, or (at your option) any later version.
# 
# ECS is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with ECS. If not, see <http://www.gnu.org/licenses/>.


module Admin::OrganizationsHelper
end

app/views/admin/organizations/_form.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<% if @organization.errors.any? %>
  <div id="error_explanation">
    <h2><%= pluralize(@organization.errors.count, "error") %> prohibited
      this Organization from being updated</h2>
    <ul>
      <% @organization.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<table>
<tr>
<td><label for="organization_name" class="box2 table-resource-label">Name:</label></td>
<td><%= h form.text_field :name %></td>
</tr>
<tr>
<td><label for="organization_abrev" class="box2 table-resource-label">Abreviation:</label></td>
<td><%= h form.text_field :abrev %></td>
</tr>
</table>

<p>
<div class="formular-input-width">
<div class="table-border">
<div class="table-header">
  <label for="organization_description" class="table-resource-label">Description (optional):</label>
</div>
<%= h form.text_area :description, :rows => 2 , :style => "width:99.5%" %>
</div>
</div>

app/views/admin/organizations/edit.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">Edit Organization</h1>

<p>
<%= link_to 'Show', admin_organization_path(@organization)%> |
<%= link_to 'Back', admin_organizations_path %>
</p>

<p>
<%= form_for [:admin, @organization], :method => :put do |form| %>
  <p><%= form.submit 'Save' %></p>
  <%= render :partial => form %>
  <p><%= form.submit 'Save' %></p>
<% end %>
</p>

<p>
<%= link_to 'Show', admin_organization_path(@organization)%> |
<%= link_to 'Back', admin_organizations_path %>
</p>

app/views/admin/organizations/list.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">Listing Organizations</h1>

<%= link_to 'New organizations', :action => 'new' %>

<p>

<table class="list">

  <TR class="table-resource-label">
    <TH class="box2">ID</TH>
    <TH class="box2">Name</TH>
    <TH class="box2">&uarr; Abreviation</TH>
    <TH class="box2">Description</TH>
    <TH class="box2" align="center">Operations</TH>
  </TR>
  <tr></tr>
  
  <% for organization in @organizations.sort{|x,y| x.abrev.downcase <=> y.abrev.downcase} %>
  	<tr valign="top" class="<%= cycle('list-line-odd', 'list-line-even') %>">
      <TD> <%= organization.id %></TD>
  		<TD> <%= h organization.name %> </TD>
  		<TD class="center"> <%= h organization.abrev %> </TD>
  		<TD> <%= h truncate(organization.description, :length => 80) %> </TD>
  		<TD>
  			<%= link_to 'Show', admin_organization_path(organization) %>
  			<%= link_to 'Edit', edit_admin_organization_path(organization) %>
  			<%= link_to 'Destroy', { :action => 'destroy', :id => organization }, :confirm => 'Are you sure?', :method => :delete %>
  		</TD>
    </tr>
  <% end %>

</table>

</p>

app/views/admin/organizations/new.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">New Abreviation</h1>

<p>
<%= link_to 'Back', admin_organizations_path %>
</p>

<p>
<%= form_for [:admin, @organization] do |form| %>
  <p><%= form.submit "Create" %></p>
  <%= render :partial => form %>
  <p><%= form.submit "Create" %></p>
<% end %>
</p>

<p>
<%= link_to 'Back', admin_organizations_path %>
</p>

app/views/admin/organizations/show.html.erb
<!--
Copyright (C) 2007, 2008, 2009, 2010 Heiko Bernloehr (FreeIT.de).

This file is part of ECS.

ECS is free software: you can redistribute it and/or modify it
under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

ECS is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public
License along with ECS. If not, see <http://www.gnu.org/licenses/>.
-->


<h1 class="box1">Show Organization</h1>

<%= link_to 'Edit', edit_admin_organization_path(@organization) %> |
<%= link_to 'Back', admin_organizations_path %>

<p>
  <label class="box2 table-resource-label">Name:</label>
  <%= @organization.name %>
</p>

<p>
<div class="formular-input-width">
<div class="table-border">
<div class="table-header">
  <label class="table-resource-label">Description (optional):</label>
</div>
    <%= h(@organization.description).gsub(/\r\n/, '<BR>') %>
</div>
</div>
</p>

<p>
  <label class="box2 table-resource-label">Abrev.:</label>
  <%= @organization.abrev %>
</p>

<p>
<%= link_to 'Edit', edit_admin_organization_path(@organization) %> |
<%= link_to 'Back', admin_organizations_path %>
</p>